#define _CRT_SECURE_NO_DEPRECATE
#define NOFOOTER
#define EJUDGE

#include "testlib.h"
#include <utility>

using namespace std;

int c[31][31];
int a[31][31];
int row[31], col[31];

int main(int argc, char * argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    int m = inf.readInt();
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            c[i][j] = inf.readInt();
        }
    }

    int x = -1, y;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            a[i][j] = ouf.readInt();
            if (a[i][j] == 0 && i == 0 && j == 0) {
                if (ans.readInt() == 0) quit(_ok, "no solution");
            }
            if (a[i][j] < 1 || a[i][j] > 3) quit(_wa, "wrong colors");
            if (c[i][j] != 0 && c[i][j] != a[i][j]) quit(_wa, "wrong colors");
            if (a[i][j] != 3) x = i, y = j;
        }
    }
    memset(row, 0, sizeof(row));
    memset(col, 0, sizeof(col));
    if (x == -1) quit(_ok, "all is green");
    row[x] = col[y] = a[x][y];
    for (int i = 0; i < n; ++i) {
        if (a[i][y] == 3) row[i] = 3 - col[y]; else row[i] = col[y];
    }
    for (int j = 0; j < m; ++j) {
        if (a[x][j] == 3) col[j] = 3 - row[x]; else col[j] = row[x];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if ((row[i] | col[j]) != a[i][j]) quit(_wa, "such coloring is not correct");
        }
    }

    quit(_ok, "");

    return 0;
}
